#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <assert.h>
#include <errno.h>


/*
** Lnge des Empfangspuffers
*/
#define BUFLEN 80


int main(int argc, char **argv)
{
    /*
    ** Argument prfen und holen
    */
    if (argc < 2) {
        fprintf(stderr, "Usage: udp_client <message>\n");
        exit(1);
    }
    char *msg = argv[1];


    /*
    ** Erzeugen des Datagramm-Sockets
    */
    int sockfd = socket(PF_INET, SOCK_DGRAM, 0);
    if (sockfd < 0) {
        perror("Can't create socket");
        exit(1);
    }


    /*
    ** Initialisieren der Adre-Struktur: Port 2525
    */
    struct sockaddr_in addr;
    memset (&addr, 0, sizeof(addr));
    addr.sin_family = AF_INET;
    addr.sin_port = htons(2525);
    addr.sin_addr.s_addr = htonl(INADDR_ANY);

    
    /*
    ** Senden eines Datagramms an Port 2525
    */
    int msgLen = strlen(msg)+1;

    int res = sendto(sockfd, msg, msgLen, 0,
                     (struct sockaddr *)&addr, sizeof(addr));
    if (res < 0) {
        perror("Can't write");
        exit(3);
    }


    
    /*
    ** Empfangen eines Antwort-Datagramms
    */
    char buf[BUFLEN];

    int len = recvfrom(sockfd, buf, BUFLEN-1, 0, NULL, 0);
    if (len < 0) {
        perror("Can't read");
        exit(5);
    }
    buf[BUFLEN-1] = '\0';
    
    printf("%s\n", buf);

    
    /*
    ** Schlieen des Sockets
    */
    close(sockfd);
    exit(0);
}
