#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <assert.h>
#include <errno.h>
#include <string.h>

/*
** Lnge des Empfangspuffers
*/
#define BUFLEN 80

int
main(int argc, char **argv)
{

    /*
    ** Erzeugen des Datagramm-Sockets
    */
    int sockfd = socket(PF_INET, SOCK_DGRAM, 0);
    if (sockfd < 0) {
        perror("Can't create socket");
        exit(1);
    }


    /*
    ** Initialisieren der Adre-Struktur: Port 2525
    */
    struct sockaddr_in addr;
    memset (&addr, 0, sizeof(addr));
    addr.sin_family = AF_INET;
    addr.sin_port = htons(2525);
    addr.sin_addr.s_addr = htonl(INADDR_ANY);


    /*
    ** Binden des Server-Sockets an Port 2525
    */
    if (bind(sockfd, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
        perror("Can't bind");
        exit(2);
    }


    char buf[BUFLEN];
        
    do {
        /*
        ** Empfangen eines Datagramms
        ** peerAddr nimmt die Adresse des Kommunikationspartners auf
        */
        struct sockaddr_in peerAddr;
        int peerAddrLen = sizeof(peerAddr);

        int len = recvfrom(sockfd, buf, BUFLEN-1, 0,
                           (struct sockaddr *) &peerAddr,
                           &peerAddrLen);
        if (len < 0) {
            perror("Can't read");
            exit(5);
        }
        buf[BUFLEN-1] = '\0';

        printf("%s\n", buf);
        
        
        /*
        ** Senden eines Antwort-Datagramms an den Client
        */
        char *msg = "Hello old friend!";
        int msgLen = strlen(msg)+1;

        int res = sendto(sockfd, msg, msgLen, 0,
                         (struct sockaddr *) &peerAddr,
                         peerAddrLen);
        if (res < 0) {
            perror("Can't write");
            exit(5);
        }

    } while (strcmp(buf, "quit") != 0);


    /*
    ** Schlieen des Sockets
    */
    close(sockfd);
    exit(0);
}
